% This script reads the output from Hadley.f and creates plots. 
% Options:
  contype=3;    % Set to 1 for solid black positive contours, dashed black
                % negative contours; 2 for colored contours, 3 for filled
                % contours
  cmp='gray';   % Colormap, if colored plots selected
  fcmp='y';     % Reverse colormap?
  ncon=15;       % Number of contours. Set to 0 for automatic. 
%-------------------------------------------------------------------------
sfile=input('File name (default = output)','s');
if isempty(sfile)
   sfile='output/';
else
   sfile=char(strcat(char('output_'),char(sfile),char('/')));
end   
sfsize=max(size(sfile))+2;
file=strcat(sfile,'x.out');
load(file)
file=strcat(sfile,'t.out');
load(file)
file=strcat(sfile,'p.out');
load(file)
file=strcat(sfile,'prms.out');
load(file)
npl=prms(1);np=prms(2);nlo=prms(3)-2;plotfreq=prms(4);
days=plotfreq*(1:npl);
sa=size(x);
sam=max(sa);
carray=cellstr(num2str(transpose(1:sam)));
carray=[carray;cellstr('Exit')];
ss=sa(1,2)-1;
s1=size(t);
ss1=s1(1,1);
fr=1:ss1;
xt=x+0.5.*(x(2)-x(1));
x2=xt(1:ss);
m=zeros(1,31);
for j=1:8
   m(j)=j;
end   
m(31)=9;
for j=9:30
    m(j)=j+1;
end    
ri=1; rj=1;rk=1;
mitems={'Time-Latitude Plots','Time-Averaged Plots','Cross-sections', ...
        'Soundings','Stop'};
%
while ri < max(size(mitems))
    ri=menu('Plots',mitems);
    if ri == max(size(mitems))
        break
    elseif ri == 1    
%
    menuitems={'Precipitation',...
       'Omega at 800 hPa','Surface v','Surface u','Surface T',...
       'Net absorbed shortwave',...
       'Outgoing longwave','TC Potential intensity',...
       'High cloud fraction','Low cloud fraction ','Back to main menu'};
%  
    rj=1;
    while rj < max(size(menuitems))
        %
        rj=menu('Time-Latitude Plots:',menuitems);
        %
        if rj == max(size(menuitems))
            break          
        elseif rj == 2
            file=strcat(sfile,'omegat.out');          
            tit='800 hPa Omega (mb/hour)';
         elseif rj == 1
            file=strcat(sfile,'precip.out');
            tit='Precipitation rate (mm/day)';
          elseif rj == 3
            file=strcat(sfile,'vt.out');
            tit='Surface v (m/s)';
          elseif rj == 4
            file=strcat(sfile,'ut.out');
            tit='Surface u (m/s)';
          elseif rj == 5
            file=strcat(sfile,'sst.out');
            tit='Surface temperature (C)';
          elseif rj == 6
            file=strcat(sfile,'sw.out');
            tit='Net absorbed SW (W/m^2)';
          elseif rj == 7
            file=strcat(sfile,'olr.out');
            tit='Outgoing longwave radiation (W/m^2)';
          elseif rj == 8
            file=strcat(sfile,'mpi.out');
            tit='Potential Intensity (m/s)';
          elseif rj == 9
            file=strcat(sfile,'hc.out');
            tit='High cloud fraction';  
          elseif rj == 10
            file=strcat(sfile,'lc.out');
            tit='Low cloud fraction';  
        end
        %
        dum=load(file);
        if max(max(abs(dum))) == 0
            disp('No field to display')
            break
        end    
        if contype == 1
            if ncon == 0
                contour(t,x,max(dum',0),'k','linewidth',1.5)
                if sign(max(max(dum))) ~= sign(min(min(dum))+1e-6)
                    hold on
                    contour(t,x,min(dum',0),'--k','linewidth',1.5)
                    hold off
                end
            else
                contour(t,x,max(dum',0),ncon,'k','linewidth',1.5)
                if sign(max(max(dum))) ~= sign(min(min(dum))+1e-6)
                    hold on
                    contour(t,x,min(dum',0),ncon,'--k','linewidth',1.5)
                    hold off
                end
            end
        elseif contype == 2   
            if ncon == 0
                contour(t,x,dum','linewidth',1.5)
            else
                contour(t,x,dum',ncon,'linewidth',1.5)
            end       
            ct= colormap(cmp);
            if strcmpi(fcmp,'y')
                cmp2=flip(ct,1);
                colormap(cmp2)
            end
            colorbar
        elseif contype == 3   
            if ncon == 0
                contourf(t,x,dum','linewidth',1)
            else
                contourf(t,x,dum',ncon,'linewidth',1)
            end          
            ct= colormap(cmp);
            if strcmpi(fcmp,'y')
                cmp2=flip(ct,1);
                colormap(cmp2)
            end
            colorbar
        end
        set(gca,'fontweight','bold','fontsize',12)
        title(tit)
        ylabel('Latitude')
        xlabel ('Time (days)')
    end  
    %
    elseif ri == 2
        m2items={'Precipitation Rate','Surface Temperature','TOA Radiation', ...
            'Potential Intensity','Cloud Fractions','Back to main menu'};
        %
        rk=1;
        while rk < max(size(m2items))
            %
            rk=menu('Time-Averaged Plots',m2items);
            if rk == max(size(m2items))
                break
            elseif rk == 1
                file=strcat(sfile,'precip.out');
                tit='Precipitation rate (mm/day)';
                ylab='mm/day';
            elseif rk == 2
                file=strcat(sfile,'sst.out');    
                tit='Sea Surface Temperature (C)';
                ylab='C';
            elseif rk == 3
                file=strcat(sfile,'sw.out');
                file2=strcat(sfile,'olr.out');
                tit='Radiation (W/m^2)';
                leg={'Net absorbed shortwave','Outgoing longwave'};
                ylab='Wm^{-2}';
            elseif rk == 4                
                file=strcat(sfile,'mpi.out');    
                tit='Potential Intensity (m/s)';
                ylab='ms^{-1}';
            elseif rk == 5
                file=strcat(sfile,'hc.out');
                file2=strcat(sfile,'lc.out');
                tit='Cloud Fractions';
                leg={'High clouds','Low clouds'};
                ylab='Fraction';
            end
            if rk == 3 || rk == 5
                dum=load(file);
                dum2=load(file2);
                if max(abs(mean(dum,1))) == 0 || max(abs(mean(dum2,1))) == 0
                    disp('No field to display')
                    break
                end    
                plot(x,mean(dum,1),'k',x,mean(dum2,1),'--k','linewidth',1.5)
                legend(leg,'location','best')
            else
                dum=load(file);
                if max(abs(mean(dum,1))) == 0
                    disp('No field to display')
                    break
                end    
                plot(x,mean(dum,1),'k','linewidth',1.5)
            end    
            set(gca,'fontsize',12,'fontweight','bold')
            xlabel('Latitude')
            ylabel(ylab)
            title(tit)
        end    
        %
    elseif ri == 3    
        carray=cellstr(num2str(days'));
        carray=[carray;cellstr('Back to main menu')]; %#ok<AGROW>
        %
        nd=0;
        while nd < max(size(carray))
            %
        nd=menu('Choose day for cross-sections',carray);
        %
        if nd == max(size(carray))
            break
        else
            menuitems={'Streamfunction','Meridional velocity','Omega', ...
                'Zonal velocity','Angular momentum and streamfunction', ...
                'Relative humidity','Perturbation temperature', ...
                'Updraft mass flux','Downdraft mass flux','Cloud fraction', ...
                'Back'};
            rd=0;
            while rd < max(size(menuitems))
            %
            rd=menu('Cross-sections:',menuitems);
            %
            if rd == max(size(menuitems))
                break
            elseif rd == 1
                file=strcat(sfile,'psi.out');
                tit='Streamfunction';
            elseif rd == 2
                file=strcat(sfile,'psi.out');
                tit='Meridional Wind Speed (m/s)';  
            elseif rd == 3
                file=strcat(sfile,'omegal.out');
                tit='Omega (mb/hour)';    
            elseif rd == 4
                file=strcat(sfile,'ul.out');
                tit='Zonal wind speed (m/s)';   
            elseif rd == 5
                file=strcat(sfile,'ul.out');
                file2=strcat(sfile,'psi.out');
                tit='Angular momentum and streamfunction';    
            elseif rd == 6
                file=strcat(sfile,'rh.out');
                tit='Relative humidity (%)'; 
            elseif rd == 7
                file=strcat(sfile,'temp.out');
                tit='Perturbation temperature (K)';    
            elseif rd == 8
                file=strcat(sfile,'mul.out');
                tit='Updraft mass flux'; 
            elseif rd == 9
                file=strcat(sfile,'mdl.out');
                tit='Downdraft mass flux';   
            elseif rd == 10
                file=strcat(sfile,'cld.out');
                tit='Cloud fraction';       
            end
            dum=load(file);
            dum=reshape(dum,[np,npl,nlo]);
            dum=squeeze(dum(:,nd,:));
            tit=char([char(tit),char(', day '),char(num2str(days(nd)))]);
            if rd == 2
                v=zeros(np,nlo);
                for k=1:np-1
                    v(k,:)=-100.*9.8*(dum(k+1,:)-dum(k,:))/(p(k+1)-p(k));
                end
                dum=v;
            end   
            %
            if max(max(abs(dum))) == 0
                disp('No field to display')
                break
            end    
            if rd == 5      % Special case of M and Psi
                dum2=load(file2);
                dum2=reshape(dum2,[np,npl,nlo]);
                dum2=squeeze(dum2(:,nd,:));
                costhe=cos(pi.*x./180);
                a=6.38e6;
                Omeg=2*pi/(24*3600);
                M=a*costhe.*(a.*costhe.*Omeg+dum);
                contour(x,p,M,20,'k','linewidth',1.5)
                hold on
                contour(x,p,dum2,'--k','linewidth',1)
                hold off
            else                  
                %
                if contype == 1
                    if ncon == 0
                        contour(x,p,max(dum,0),'k','linewidth',1.5)
                        if sign(max(max(dum))) ~= sign(min(min(dum))+1e-6)
                            hold on
                            contour(x,p,min(dum,0),'--k','linewidth',1.5)
                            hold off
                        end
                    else
                        contour(x,p,max(dum,0),ncon,'k','linewidth',1.5)
                        if sign(max(max(dum))) ~= sign(min(min(dum))+1e-6)
                            hold on
                            contour(x,p,min(dum,0),ncon,'--k','linewidth',1.5)
                            hold off
                        end
                    end
                elseif contype == 2   
                    if ncon == 0
                        contour(x,p,dum,'linewidth',1.5)
                    else
                        contour(x,p,dum,ncon,'linewidth',1.5)
                    end       
                    ct= colormap(cmp);
                    if strcmpi(fcmp,'y')
                        cmp2=flip(ct,1);
                        colormap(cmp2)
                    end
                    colorbar
                elseif contype == 3   
                    if ncon == 0
                        contourf(x,p,dum,'linewidth',1)
                    else
                        contourf(x,p,dum,ncon,'linewidth',1)
                    end          
                    ct= colormap(cmp);
                    if strcmpi(fcmp,'y')
                        cmp2=flip(ct,1);
                        colormap(cmp2)
                    end
                    colorbar
                end
            end    
            set(gca,'ydir','reverse','fontsize',12,'fontweight','bold')
            xlabel('Latitude')
            ylabel('Pressure (hPa)')
            title(tit)
            end
        end   
        end   
        %
    elseif ri == 4
        carray=cellstr(num2str(days'));
        carray=[carray;cellstr('Exit')]; %#ok<AGROW>
        %
        nd=0;
        while nd < max(size(carray))
            %
            nd=menu('Choose day for soundings',carray);
            %
            if nd == max(size(carray))
                break
            else        
               jj=1;
               while jj == 1
                   file=strcat(sfile,'p.out');
                   load(file)
                   file=strcat(sfile,'tempnet.out');
                   load(file)
                   file=strcat(sfile,'rh.out');
                   load(file)
                   carray2=cellstr(num2str(transpose(1:nlo)));
                   carray2=[carray2;cellstr('Exit')]; %#ok<AGROW>
                   nsound=menu('Choose sounding column number',carray2);
                   if nsound == sam+1
                      file='output/skewt.out';
                      break
                   end   
                   psound=p;
                   dum=tempnet;
                   dum=reshape(dum,[np,npl,nlo]);
                   tsound=squeeze(dum(:,nd,nsound))-273.15;
                   dum=rh;
                   dum=reshape(dum,[np,npl,nlo]);
                   rhsound=squeeze(dum(:,nd,nsound));
                   success=skewt(psound,tsound',rhsound');
                   lattit=x(nsound);
                   latlab='N';
                   if lattit < 0
                       latlab='S';
                   end    
                   titstring=['Sounding at ' num2str(lattit),'^o ',latlab,', Day ',num2str(days(nd))];
                   title(titstring,'fontweight','bold','fontsize',12)
                   file=strcat(sfile,'sst.out');
                   load(file)
                   sstsound=sst(end,nsound);
                   es=6.112*exp(17.67*tsound./(243.5+tsound));
                   qr=0.01*rhsound*0.622.*es./(psound-es);
                   [~,vmax,~,~]= pcminstd(sstsound,1010.0,psound,tsound,qr);
                   %disp([sstsound,vmax])
                   %
               end
            end
        end   
    end   
end
   
   %{
   mf=max(size(file))-4;
   gg=file(sfsize:mf);
   fig=strcat(gg,'.png');
   print(fig,'-dpng','-r300')
   %}
   %exportfig(gcf,fig,'format','png','color','rgb','bounds','loose','Renderer','Painters','Resolution',300);

